// C Header File
// Created 6/1/03; 4:16:31 AM

enum {EXIT, CHAT, ERNET, CATALOG};
char location=CHAT;	//stores which screen we are looking at

enum {MENU,OPTIONS,SEND_A_FILE,ABOUT};
char ernet_location=MENU;

enum {/*MENU,*/EDITHANDLE=1,CONTRAST,IMCHECKBOX};
char ernet_options_location=MENU; //0 for menu and 1 for handle

BOOL imcheckbox_enabled=0;
#define ernet_menu_max 2	//starts counting with 0
char ernet_menu_choice=0;
#define ernet_options_menu_max 2
char ernet_options_menu_choice=0;
int handle_offset=7;
#define catalog_menu_max 7
char catalog_menu_choice=0;
char catcus[208]={'H','e','l','l','o',[6 ... 25]=0,'H','o','w',' ','a','r','e',' ','y','o','u','?',[38 ... 51]=0,'G','o','o','d',[56 ... 77]=0,'W','h','a','t','?',[83 ... 103]=0,'T','h','i','s',' ','i','s',' ','c','o','o','l','.',[117 ... 129]=0,'B','l','a','n','k',[135 ... 155]=0,'B','l','a','n','k',[161 ... 181]=0,'B','l','a','n','k',[187 ... 207]=0};
char catalog_menu_edit=0;
int cat_offset=7;

BOOL cursor=TRUE;
char chat_text[100][27]={{'W','e','l','c','o','m','e'}}; //26 chars max - need an extra for terminating 0
char chat_text_offset=0;
int chat_text_line=1;
void *VirtualScreen;
char Handle[10]={'D','e','f','a','u','l','t'};
char chat_msg[25];
int chat_msg_offset=0;

void DrawScreen(void){
	int x;
	FontSetSys(F_6x8);
	//ScrRectFill(&(SCR_RECT){{0, 91, 159, 99}},&(SCR_RECT){{0, 0, 159, 99}}, A_REVERSE);
	clrscr();
	DrawLine(0,91,159,91,A_NORMAL);
	DrawLine(0,90,159,90,A_NORMAL);
	DrawStr(0,93,"Write",A_NORMAL);
	DrawStr(32,93,"Catlg",A_NORMAL);
	DrawStr(64,93,"erNET",A_NORMAL);
	DrawStr(130,93,"Exit",A_NORMAL);
	DrawLine(31,92,31,99,A_NORMAL);
	DrawLine(63,92,63,99,A_NORMAL);
	DrawLine(96,92,96,99,A_NORMAL);
	DrawLine(127,92,127,99,A_NORMAL);
	ScrRectFill(&(SCR_RECT){{0, 91, 159, 99}},&(SCR_RECT){{0, 0, 159, 99}}, A_XOR);
	if(location==CHAT){
		DrawLine(0,81,159,81,A_NORMAL);
		DrawLine(0,80,159,80,A_NORMAL);
		ScrRectFill(&(SCR_RECT){{0, 91, 31, 99}},&(SCR_RECT){{0, 0, 159, 99}}, A_XOR);
		printf_xy(0,82,cursor?"%s|":"%s ",chat_msg);
		for(x=0;x<10;x++) DrawStr(0,8*x,chat_text[chat_text_offset+x],A_NORMAL);
	}
	else if(location==CATALOG){
		ScrRectFill(&(SCR_RECT){{31, 91, 63, 99}},&(SCR_RECT){{0, 0, 159, 99}}, A_XOR);
		DrawStr(32,1,"Personal Catalog",A_NORMAL);
		ScrRectFill(&(SCR_RECT){{0, 0, 159, 8}},&(SCR_RECT){{0, 0, 159, 99}}, A_XOR);
		for(x=0;x<8;x++) printf_xy(1,11+10*x,"[%i] %s",x+1,catcus+26*x);
    if(catalog_menu_edit==0){
			SCR_RECT temp={{0, 10+10*catalog_menu_choice, 159, 10+8+10*catalog_menu_choice}};
			ScrRectFill(&temp, &(SCR_RECT){{0, 0, 159, 99}}, A_XOR);
		}
		if(catalog_menu_edit!=0){
			unsigned char wcat=catalog_menu_choice*26; cat_offset=strlen(catcus+wcat);
			printf_xy(25,1+catalog_menu_edit*10,cursor?"%s":"%s|",catcus+wcat);
		}
	}
	
	else if(location==ERNET){
		ScrRectFill(&(SCR_RECT){{63, 91, 96, 99}},&(SCR_RECT){{0, 0, 159, 99}}, A_XOR);
		DrawStr(29,1,"Welcome to erNET!",A_NORMAL);
		DrawStr(5,11,"Options    >",A_NORMAL);
		DrawStr(5,21,"Send a file>",A_NORMAL);
		DrawStr(5,31,"About      >",A_NORMAL);
		DrawLine(80,9,80,90,A_OR);
		ScrRectFill(&(SCR_RECT){{0, 0, 159, 8}},&(SCR_RECT){{0, 0, 159, 99}}, A_XOR);
		if(ernet_location==MENU){
			SCR_RECT temp={{0, 10+10*ernet_menu_choice, 79, 10+8+10*ernet_menu_choice}};
			ScrRectFill(&temp, &(SCR_RECT){{0, 0, 159, 99}}, A_XOR);
		}
		if(ernet_location==OPTIONS){
			FontSetSys(F_6x8);
			printf_xy(86,10,"--Options--");
			FontSetSys(F_4x6);
			printf_xy(85,21,ernet_options_location!=EDITHANDLE?"Handle: %s":(cursor?"Handle: %s":"Handle: %s|"), Handle);
			printf_xy(85,31,ernet_options_location!=CONTRAST?"Contrast":"Contrast -/+");
			printf_xy(93,41,"Personal IM");
			DrawClipRect(&(WIN_RECT){86, 41, 90, 45},&(SCR_RECT){{0, 0, 159, 99}},A_NORMAL);
			if(imcheckbox_enabled) DrawChar(86,41,16,A_NORMAL);
			DrawLine(80,66,159,66,A_NORMAL);
			//EDIT NOTHING//
			if(ernet_options_location==MENU){
				printf_xy(81,70,"Select an option or");
				printf_xy(81,76,"press the left arrow");
				printf_xy(81,82,"to go back.");
			}
			//EDIT HANDLE//
			if(ernet_options_location==EDITHANDLE){
				printf_xy(81,70,"Edit your handle.");
				printf_xy(81,76,"When you are done");
				printf_xy(81,82,"press enter.");
			}
			//EDIT CONTRAST//
			if(ernet_options_location==CONTRAST){
				printf_xy(81,70,"Press the plus or minus");
				printf_xy(81,76,"keys to change the");
				printf_xy(81,82,"contrast.");
			}
			SCR_RECT temp={{81, 20+10*ernet_options_menu_choice, 81+79, 20+6+10*ernet_options_menu_choice}};
			if(!ernet_options_location) ScrRectFill(&temp, &(SCR_RECT){{0, 0, 159, 99}}, A_XOR);
		}
		if(ernet_location==SEND_A_FILE){
			FontSetSys(F_4x6);
			printf_xy(86,10,"Not yet implemented.");
		}
		if(ernet_location==ABOUT){
			FontSetSys(F_4x6);
			printf_xy(98,10,"erCHAT v1.0");
			printf_xy(86,18,"powered by: erNET");
			printf_xy(98,26,"by: er?SOFT");
			printf_xy(88,42,"Lead Programers:");
			printf_xy(94,50,"Eric Anderson");
			printf_xy(111,58,"&&");
			printf_xy(96,64,"Robert Honer");
			printf_xy(105,80,"2003");
		}
	}
	
	memcpy(LCD_MEM,VirtualScreen,LCD_SIZE);
}

void StringToScreen(char string[]){
	unsigned int x,y,z;
	for(x=0;x<strlen(string)/27+1;x++){
		if(chat_text_line==99){
			for(y=0;y<98;y++) for(z=0;z<27;z++) chat_text[y][z]=chat_text[y+1][z];
			chat_text_offset--;
			chat_text_line--;
		}
		for(y=0;y<26 && x*26+y<strlen(string);y++){
			chat_text[chat_text_line][y]=string[x*26+y];
		}
		if(++chat_text_line-chat_text_offset>10) chat_text_offset++;
	}
}

